// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'IcXMLParser.pas' rev: 5.00

#ifndef IcXMLParserHPP
#define IcXMLParserHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <WinInet.hpp>	// Pascal unit
#include <Registry.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------
#pragma link "inet.lib"
#include "IcCodePages.hpp"

namespace Icxmlparser
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TWriteMode { wmStandard, wmStandalone, wmLinkedDTD, wmExternalDTD, wmAllExternal };
#pragma option pop

#pragma option push -b-
enum TByteOrder { boLittleEndian, boBigEndian };
#pragma option pop

typedef void __fastcall (__closure *TFileNotFoundEvent)(System::TObject* Sender, AnsiString FileName
	);

typedef AnsiString TDOMString;

typedef char TDOMChar;

typedef char *TDOMPChar;

class DELPHICLASS TStringBuffer;
class PASCALIMPLEMENTATION TStringBuffer : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	AnsiString Data;
	int Size;
	int Pos;
	
public:
	__fastcall TStringBuffer(int dataSize);
	void __fastcall Cat(char c);
	void __fastcall StrCat(AnsiString s);
	void __fastcall Clear(void);
	AnsiString __fastcall DataString(void);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TStringBuffer(void) { }
	#pragma option pop
	
};


class DELPHICLASS EIcDOMException;
class PASCALIMPLEMENTATION EIcDOMException : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
protected:
	Byte FCode;
	AnsiString FMessage;
	AnsiString __fastcall ErrCodeToString(void);
	
public:
	__fastcall EIcDOMException(Byte code, AnsiString messageStr);
	__fastcall virtual ~EIcDOMException(void);
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIcDOMException(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIcDOMException(int Ident)/* overload */ : Sysutils::Exception(
		Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIcDOMException(int Ident, const System::TVarRec * Args
		, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIcDOMException(const AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIcDOMException(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIcDOMException(int Ident, int AHelpContext)/* overload */
		 : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIcDOMException(System::PResStringRec ResStringRec
		, const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(
		ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
};


class DELPHICLASS TIcXMLNode;
class DELPHICLASS TIcXMLDocument;
class DELPHICLASS TIcContainer;
class PASCALIMPLEMENTATION TIcXMLNode : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	AnsiString FNodeName;
	AnsiString FNodeValue;
	Byte FNodeType;
	TIcXMLNode* FParent;
	TIcXMLNode* FNext;
	TIcXMLNode* FPrev;
	TIcXMLDocument* FDocument;
	__fastcall virtual TIcXMLNode(AnsiString tagname, Byte nodeType, TIcXMLDocument* owner);
	__fastcall virtual ~TIcXMLNode(void);
	bool __fastcall IsAncestor(TIcXMLNode* queryNode);
	AnsiString __fastcall TypeToTypeString(void);
	bool __fastcall ChildTypeAllowed(TIcXMLNode* newChildNode);
	virtual void __fastcall Write(Classes::TStream* stream, int l);
	virtual void __fastcall Validate(void);
	virtual void __fastcall Normalize(void);
	
public:
	virtual TIcXMLNode* __fastcall Previous(void);
	virtual TIcXMLNode* __fastcall Next(void)/* overload */;
	TIcXMLNode* __fastcall Next(int offset)/* overload */;
	virtual TIcXMLNode* __fastcall CloneNode(void);
	AnsiString __fastcall GetName(void);
	AnsiString __fastcall GetValue(void);
	Byte __fastcall GetType(void);
	void __fastcall SetName(AnsiString name);
	void __fastcall SetValue(AnsiString value);
	void __fastcall SetType(Byte ntype);
	TIcXMLNode* __fastcall PreviousSibling(void);
	TIcXMLNode* __fastcall NextSibling(void);
	TIcXMLNode* __fastcall GetParent(void);
	TIcXMLDocument* __fastcall GetOwnerDocument(void);
};


class DELPHICLASS TIcNodeList;
class PASCALIMPLEMENTATION TIcNodeList : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TIcXMLNode* Froot;
	
protected:
	TIcXMLNode* FLast;
	TIcXMLNode* FParent;
	TIcXMLDocument* FOwner;
	void __fastcall addList(TIcNodeList* list);
	
public:
	__fastcall virtual TIcNodeList(TIcXMLDocument* owner)/* overload */;
	__fastcall virtual TIcNodeList(TIcXMLDocument* owner, TIcXMLNode* Parent)/* overload */;
	TIcXMLNode* __fastcall GetLast(void)/* overload */;
	TIcXMLNode* __fastcall GetLast(Byte nType)/* overload */;
	virtual TIcXMLNode* __fastcall RemoveChild(TIcXMLNode* oldChild)/* overload */;
	virtual TIcXMLNode* __fastcall RemoveChild(AnsiString name, Byte nType)/* overload */;
	__fastcall virtual ~TIcNodeList(void);
	virtual TIcXMLNode* __fastcall Item(int index, Byte nType);
	virtual int __fastcall Length(void);
	TIcXMLNode* __fastcall GetFirst(void);
	TIcXMLNode* __fastcall GetRoot(Byte nType);
	void __fastcall InsertBefore(TIcXMLNode* newChild, TIcXMLNode* refChild);
	void __fastcall InsertAfter(TIcXMLNode* newChild, TIcXMLNode* refChild);
	void __fastcall ReplaceChild(TIcXMLNode* newChild, TIcXMLNode* oldChild);
	void __fastcall AppendChild(TIcXMLNode* newChild);
	bool __fastcall HasChildNodes(void);
	TIcXMLNode* __fastcall GetChild(AnsiString name, Byte nType);
	void __fastcall Clear(void);
};


class DELPHICLASS TIcXMLComment;
class DELPHICLASS TIcXMLPi;
class DELPHICLASS TIcXMLAttr;
class PASCALIMPLEMENTATION TIcContainer : public TIcXMLNode 
{
	typedef TIcXMLNode inherited;
	
protected:
	TIcNodeList* FDataList;
	void __fastcall GetTypeList(TIcNodeList* list, Byte nType);
	void __fastcall FSetAttribute(AnsiString name, AnsiString value);
	__fastcall virtual TIcContainer(AnsiString tagname, Byte nodeType, TIcXMLDocument* owner);
	
public:
	TIcXMLNode* __fastcall GetFirstNode(void);
	void __fastcall SetComment(TIcXMLComment* comment);
	TIcXMLComment* __fastcall GetFirstComment(void);
	bool __fastcall HasComment(void);
	void __fastcall GetComments(TIcNodeList* list);
	void __fastcall RemoveComment(TIcXMLComment* Node);
	void __fastcall SetPI(TIcXMLPi* data);
	TIcXMLPi* __fastcall GetFirstPI(void);
	void __fastcall GetPIs(TIcNodeList* list);
	bool __fastcall HasPI(void);
	void __fastcall RemovePI(TIcXMLPi* Node)/* overload */;
	TIcXMLPi* __fastcall RemovePI(AnsiString name)/* overload */;
	AnsiString __fastcall GetAttribute(AnsiString name);
	bool __fastcall HasAttribute(void);
	void __fastcall SetAttribute(AnsiString name, AnsiString value);
	TIcXMLAttr* __fastcall GetAttributeNode(AnsiString name);
	TIcXMLAttr* __fastcall SetAttributeNode(TIcXMLAttr* newAttr);
	TIcXMLAttr* __fastcall GetFirstAttribute(void);
	void __fastcall GetAttributes(TIcNodeList* list);
	TIcXMLAttr* __fastcall RemoveAttribute(AnsiString name);
	TIcXMLAttr* __fastcall RemoveAttributeNode(TIcXMLAttr* oldAttr);
	TIcXMLNode* __fastcall RemoveNode(TIcXMLNode* oldNode);
	void __fastcall InsertNode(TIcXMLNode* newNode, TIcXMLNode* refNode);
	TIcNodeList* __fastcall GetNodeList(void);
protected:
	#pragma option push -w-inl
	/* TIcXMLNode.Destroy */ inline __fastcall virtual ~TIcContainer(void) { }
	#pragma option pop
	
};


class DELPHICLASS TIcXMLParser;
class DELPHICLASS TLexAnalyzer;
class DELPHICLASS TInputBuffer;
class PASCALIMPLEMENTATION TInputBuffer : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	AnsiString FFileName;
	Classes::TStream* FStream;
	char *lbuf;
	char *rbuf;
	int lexBegin;
	int lexForward;
	int rest;
	bool canLoad;
	char __fastcall _GetChar(void);
	void __fastcall _UnGetChar(void);
	
public:
	__fastcall TInputBuffer(void);
	__fastcall TInputBuffer(AnsiString fname);
	__fastcall TInputBuffer(Classes::TStream* stream);
	void __fastcall Init(Classes::TStream* stream);
	__fastcall virtual ~TInputBuffer(void);
	char __fastcall GetChar(void);
	void __fastcall UnGetChar(void);
	AnsiString __fastcall GetChars(int count);
	void __fastcall UnGetChars(int count);
	char __fastcall GetPrevChar(void);
	void __fastcall SetFileName(AnsiString fName);
};


class DELPHICLASS TSymTab;
class PASCALIMPLEMENTATION TSymTab : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Classes::TList* hs[211];
	int LastChar;
	int LastEntry;
	int __fastcall hash(AnsiString s);
	
public:
	__fastcall TSymTab(void);
	__fastcall virtual ~TSymTab(void);
	int __fastcall Lookup(AnsiString s);
	int __fastcall Insert(AnsiString s, const int t);
	AnsiString __fastcall GetLexemByToken(int t);
	int __fastcall Count(void);
	int __fastcall GetToken(int index);
	AnsiString __fastcall GetLexem(int index);
	char * __fastcall GetLexemPtr(int index);
};


class DELPHICLASS TSTEntry;
class PASCALIMPLEMENTATION TSTEntry : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	char *LexPtr;
	int Token;
	int Value;
	__fastcall TSTEntry(int t, char * ptr, int val);
	void __fastcall SetValues(int t, char * ptr, int val);
	void __fastcall Copy(TSTEntry* entry);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSTEntry(void) { }
	#pragma option pop
	
};


class DELPHICLASS TXMLStack;
class DELPHICLASS TXMLStackElement;
class PASCALIMPLEMENTATION TXMLStackElement : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	TIcXMLNode* Item;
	TXMLStackElement* Prev;
	__fastcall TXMLStackElement(TIcXMLNode* item, TXMLStackElement* prev);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TXMLStackElement(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TXMLStack : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TXMLStackElement* Head;
	
public:
	__fastcall TXMLStack(void);
	__fastcall virtual ~TXMLStack(void);
	void __fastcall Push(TIcXMLNode* elem);
	AnsiString __fastcall Pop(void);
	TIcXMLNode* __fastcall GetHead(void);
};


struct TAnalyzerState;
class PASCALIMPLEMENTATION TLexAnalyzer : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
protected:
	TInputBuffer* Buffer;
	TInputBuffer* FirstBuffer;
	TInputBuffer* SecondBuffer;
	TSymTab* Symbols;
	TSTEntry* PrevToken;
	TSTEntry* CurToken;
	char CurChar;
	TXMLStack* Stack;
	int LineNumber;
	AnsiString FileName;
	TIcXMLDocument* FDoc;
	bool IsPIData;
	bool IsElContent;
	bool IsCharData;
	void __fastcall Init(void);
	void __fastcall Finalize(void);
	void __fastcall ChangeBuffers(void);
	void __fastcall SkipEmpty(void);
	TAnalyzerState __fastcall GetAnalyzerState(void);
	void __fastcall SetAnalyzerState(const TAnalyzerState &state);
	virtual void __fastcall Match(int t);
	virtual void __fastcall MatchString(AnsiString str);
	virtual void __fastcall MatchTokens(int t1, int t2);
	void __fastcall RMatch(int t);
	void __fastcall RMatchString(AnsiString str);
	void __fastcall RMatchTokens(int t1, int t2);
	bool __fastcall EqualTokens(int t1, int t2);
	bool __fastcall EqualStrings(AnsiString str1, AnsiString str2);
	virtual void __fastcall LexAn(void) = 0 ;
	virtual void __fastcall Emit(int nodeType, AnsiString val) = 0 ;
	virtual void __fastcall MEmit(int nodeType, AnsiString val1, AnsiString val2) = 0 ;
	bool __fastcall ParseAttribute(AnsiString str);
	void __fastcall ParsePI(void);
	void __fastcall ParseComment(void);
	void __fastcall ParseExternalId(void);
	void __fastcall ParseTextDecl(void);
	void __fastcall ParseReference(void);
	AnsiString __fastcall SplitCDSec(void);
	AnsiString __fastcall SplitComment(void);
	AnsiString __fastcall SplitSTag(void);
	AnsiString __fastcall SplitCharData(void);
	AnsiString __fastcall SplitETag(void);
	AnsiString __fastcall SplitLiteral(void);
	AnsiString __fastcall SplitName(void);
	AnsiString __fastcall SplitPredefined(void);
	AnsiString __fastcall SplitPIData(void);
	
public:
	__fastcall virtual TLexAnalyzer(Classes::TComponent* AOwner);
	__fastcall virtual ~TLexAnalyzer(void);
	int __fastcall GetLineNumber(void);
};


class DELPHICLASS TIcErrorsList;
class PASCALIMPLEMENTATION TIcErrorsList : public Classes::TList 
{
	typedef Classes::TList inherited;
	
public:
	__fastcall virtual ~TIcErrorsList(void);
	void __fastcall CreateMessagesList(Classes::TStrings* sList);
	void __fastcall CreateNodesList(Classes::TStrings* sList);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TIcErrorsList(void) : Classes::TList() { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TIcXMLParser : public TLexAnalyzer 
{
	typedef TLexAnalyzer inherited;
	
protected:
	bool FStandardXML;
	bool FParseDTD;
	Byte FParserMode;
	TFileNotFoundEvent FFileNotFound;
	AnsiString FVersion;
	bool FFmtOut;
	Iccodepages::TEncoding FDefEncoding;
	bool FInternet;
	virtual void __fastcall LexAn(void);
	virtual void __fastcall Emit(int nodeType, AnsiString val);
	virtual void __fastcall MEmit(int nodeType, AnsiString val1, AnsiString val2);
	virtual void __fastcall Match(int t);
	virtual void __fastcall MatchString(AnsiString str);
	virtual void __fastcall MatchTokens(int t1, int t2);
	void __fastcall ParseProlog(void);
	void __fastcall ParseElement(void);
	void __fastcall ParseMisc(void);
	void __fastcall ParseXMLDecl(void);
	void __fastcall ParseDTDStag(void);
	void __fastcall ParseElCont(void);
	void __fastcall ParseCDSec(void);
	void __fastcall SetParserMode(Byte pMode);
	AnsiString __fastcall GetVersion(void);
	
public:
	TIcErrorsList* ValidationErrors;
	__fastcall virtual TIcXMLParser(Classes::TComponent* AOWner);
	__fastcall virtual ~TIcXMLParser(void);
	bool __fastcall Parse(AnsiString fname, TIcXMLDocument* &doc)/* overload */;
	bool __fastcall Parse(Classes::TStream* stream, TIcXMLDocument* &doc)/* overload */;
	bool __fastcall Validate(TIcXMLDocument* &doc);
	
__published:
	__property bool StandardXML = {read=FStandardXML, write=FStandardXML, nodefault};
	__property bool ValidateDocument = {read=FParseDTD, write=FParseDTD, nodefault};
	__property TFileNotFoundEvent OnFileNotFound = {read=FFileNotFound, write=FFileNotFound};
	__property AnsiString Version = {read=GetVersion, write=FVersion};
	__property bool FormatedOutput = {read=FFmtOut, write=FFmtOut, nodefault};
	__property bool RetrieveInternetURI = {read=FInternet, write=FInternet, nodefault};
	__property Iccodepages::TEncoding DefaultEncoding = {read=FDefEncoding, write=FDefEncoding, nodefault
		};
};


class DELPHICLASS TDOMImplementation;
class PASCALIMPLEMENTATION TDOMImplementation : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	TIcXMLDocument* FDocument;
	
public:
	__fastcall virtual TDOMImplementation(TIcXMLDocument* owner);
	virtual bool __fastcall HasFeature(AnsiString feature, AnsiString version);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TDOMImplementation(void) { }
	#pragma option pop
	
};


class DELPHICLASS TIcXMLElement;
class DELPHICLASS TIcDocumentFragment;
class DELPHICLASS TIcXMLText;
class DELPHICLASS TIcXMLCData;
class DELPHICLASS TIcGEntityReference;
class DELPHICLASS TIcDocumentType;
class PASCALIMPLEMENTATION TIcXMLDocument : public TIcContainer 
{
	typedef TIcContainer inherited;
	
private:
	TIcXMLParser* FParser;
	TIcNodeList* IdList;
	bool PrevIsText;
	TStringBuffer* InvChars;
	bool FWriteToFile;
	bool __fastcall TextCompare(AnsiString SubString, AnsiString S, bool CaseSensitive, bool WholeWords
		);
	TIcXMLParser* __fastcall GetParser(void);
	
protected:
	TDOMImplementation* FDomImplementation;
	
public:
	TWriteMode WriteMode;
	__property TIcXMLParser* Parser = {read=GetParser, write=FParser};
	__fastcall TIcXMLDocument(void)/* overload */;
	HIDESBASE void __fastcall Write(Classes::TStream* stream)/* overload */;
	HIDESBASE void __fastcall Write(AnsiString fName)/* overload */;
	__fastcall virtual ~TIcXMLDocument(void);
	TDOMImplementation* __fastcall DomImplementation(void);
	TIcXMLElement* __fastcall CreateElement(AnsiString tagName);
	TIcDocumentFragment* __fastcall CreateDocumentFragment(void);
	TIcXMLText* __fastcall CreateTextNode(AnsiString data);
	TIcXMLComment* __fastcall CreateComment(AnsiString data);
	TIcXMLCData* __fastcall CreateCDATASection(AnsiString data);
	TIcXMLPi* __fastcall CreateProcessingInstruction(AnsiString target, AnsiString data);
	TIcXMLAttr* __fastcall CreateAttribute(AnsiString name, AnsiString value);
	TIcGEntityReference* __fastcall CreateEntityReference(AnsiString name);
	TIcXMLElement* __fastcall GetDocumentElement(void);
	void __fastcall SetDocumentElement(TIcXMLElement* element);
	void __fastcall SetVersion(AnsiString version);
	AnsiString __fastcall GetVersion(void);
	void __fastcall SetEncoding(AnsiString encoding);
	AnsiString __fastcall GetEncoding(void);
	void __fastcall SetStandalone(bool standalone);
	bool __fastcall GetStandalone(void);
	void __fastcall SetDocumentType(TIcDocumentType* dtd);
	TIcDocumentType* __fastcall GetDocumentType(void);
	void __fastcall Clear(void);
	TIcXMLNode* __fastcall TakeNext(TIcXMLNode* node);
	TIcXMLNode* __fastcall Find(AnsiString text, TIcXMLNode* StartNode, int params);
	void __fastcall AssignParser(TIcXMLParser* p);
};



class DELPHICLASS TNamedNodeMap;
class PASCALIMPLEMENTATION TNamedNodeMap : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	TIcNodeList* FNodeList;
	TIcXMLDocument* FDocument;
	
public:
	__fastcall TNamedNodeMap(TIcXMLDocument* document);
	TIcXMLNode* __fastcall GetNamedItem(AnsiString name);
	TIcXMLNode* __fastcall SetNamedItem(TIcXMLNode* arg);
	TIcXMLNode* __fastcall RemoveNamedItem(AnsiString name, Byte nType);
	TIcXMLNode* __fastcall Item(int index);
	int __fastcall Length(void);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TNamedNodeMap(void) { }
	#pragma option pop
	
};


class DELPHICLASS TIcExternalNode;
class PASCALIMPLEMENTATION TIcExternalNode : public TIcXMLNode 
{
	typedef TIcXMLNode inherited;
	
private:
	AnsiString FSystem;
	AnsiString FPublic;
	bool __fastcall NormalizeURL(AnsiString sURL, char * sOutURL);
	bool __fastcall DownloadFile(AnsiString sURL, Classes::TStream* sOutStream);
	bool __fastcall GetLocalFile(AnsiString sURL, Classes::TStream* sOutStream);
	
protected:
	bool __fastcall ReadExternalFile(Classes::TStream* OutStream);
	virtual void __fastcall Retrieve(void) = 0 ;
	
public:
	void __fastcall SetSystemLiteral(AnsiString vSystem);
	void __fastcall SetPublicLiteral(AnsiString vPublic);
	AnsiString __fastcall GetSystemLiteral(void);
	AnsiString __fastcall GetPublicLiteral(void);
protected:
	#pragma option push -w-inl
	/* TIcXMLNode.Create */ inline __fastcall virtual TIcExternalNode(AnsiString tagname, Byte nodeType
		, TIcXMLDocument* owner) : TIcXMLNode(tagname, nodeType, owner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TIcXMLNode.Destroy */ inline __fastcall virtual ~TIcExternalNode(void) { }
	#pragma option pop
	
};


class DELPHICLASS TIcNotation;
class PASCALIMPLEMENTATION TIcNotation : public TIcExternalNode 
{
	typedef TIcExternalNode inherited;
	
protected:
	virtual void __fastcall Write(Classes::TStream* stream, int l);
	virtual void __fastcall Retrieve(void);
	
public:
	__fastcall TIcNotation(AnsiString name, TIcXMLDocument* owner)/* overload */;
protected:
	#pragma option push -w-inl
	/* TIcXMLNode.Destroy */ inline __fastcall virtual ~TIcNotation(void) { }
	#pragma option pop
	
};


class DELPHICLASS TIcEnumeration;
class PASCALIMPLEMENTATION TIcEnumeration : public TIcXMLNode 
{
	typedef TIcXMLNode inherited;
	
private:
	TIcNodeList* enumList;
	
protected:
	virtual void __fastcall Write(Classes::TStream* stream, int l);
	
public:
	__fastcall TIcEnumeration(TIcXMLDocument* owner)/* overload */;
	__fastcall TIcEnumeration(TIcNodeList* Enum, TIcXMLDocument* owner)/* overload */;
	void __fastcall AddElement(AnsiString name)/* overload */;
	void __fastcall AddElement(TIcXMLNode* node)/* overload */;
	__fastcall virtual ~TIcEnumeration(void);
	TIcNodeList* __fastcall GetElements(void);
};


class DELPHICLASS TIcAttDef;
class PASCALIMPLEMENTATION TIcAttDef : public TIcXMLNode 
{
	typedef TIcXMLNode inherited;
	
private:
	AnsiString FDefaultValue;
	
protected:
	void __fastcall ValidateAttDef(TIcXMLAttr* attr);
	virtual void __fastcall Write(Classes::TStream* stream, int l);
	
public:
	Byte AttributeType;
	Byte DefaultType;
	TIcEnumeration* Enumeration;
	__fastcall TIcAttDef(AnsiString name, Byte attType, AnsiString defValue, Byte defType, TIcXMLDocument* 
		owner)/* overload */;
	__fastcall TIcAttDef(AnsiString name, TIcXMLDocument* owner)/* overload */;
	__fastcall virtual ~TIcAttDef(void);
	void __fastcall SetDefaultValue(AnsiString value);
	AnsiString __fastcall GetDefaultValue(void);
	virtual TIcXMLNode* __fastcall CloneNode(void);
};


class DELPHICLASS TIcAttListDecl;
class PASCALIMPLEMENTATION TIcAttListDecl : public TIcXMLNode 
{
	typedef TIcXMLNode inherited;
	
private:
	TIcNodeList* AttList;
	
protected:
	void __fastcall ValidateAttList(TIcXMLElement* el);
	virtual void __fastcall Write(Classes::TStream* stream, int l);
	
public:
	__fastcall TIcAttListDecl(AnsiString name, TIcXMLDocument* owner)/* overload */;
	__fastcall virtual ~TIcAttListDecl(void);
	bool __fastcall AddAtt(TIcAttDef* att);
	TIcAttDef* __fastcall GetAtt(AnsiString name);
	TIcNodeList* __fastcall GetAttList(void);
};


class DELPHICLASS TIcContentModel;
class PASCALIMPLEMENTATION TIcContentModel : public TIcXMLNode 
{
	typedef TIcXMLNode inherited;
	
private:
	TIcNodeList* ChildList;
	
protected:
	virtual void __fastcall Write(Classes::TStream* stream, int l);
	
public:
	Byte ContentType;
	char Delimiter;
	__fastcall TIcContentModel(Byte contentType, TIcXMLDocument* owner)/* overload */;
	__fastcall TIcContentModel(AnsiString name, Byte contentType, TIcXMLDocument* owner)/* overload */;
		
	__fastcall TIcContentModel(AnsiString stringModel, TIcXMLDocument* owner)/* overload */;
	void __fastcall AddElement(AnsiString name, Byte param)/* overload */;
	void __fastcall AddElement(TIcContentModel* content)/* overload */;
	__fastcall virtual ~TIcContentModel(void);
	AnsiString __fastcall ToString(void);
	TIcXMLNode* __fastcall GetElement(AnsiString name);
	void __fastcall SetDelimiter(char c);
	TIcNodeList* __fastcall GetChildList(void);
};


class DELPHICLASS TIcElementDecl;
class PASCALIMPLEMENTATION TIcElementDecl : public TIcXMLNode 
{
	typedef TIcXMLNode inherited;
	
private:
	TIcContentModel* Content;
	
protected:
	virtual void __fastcall Write(Classes::TStream* stream, int l);
	void __fastcall ValidateElementDecl(TIcXMLElement* el);
	
public:
	__fastcall TIcElementDecl(AnsiString name, TIcXMLDocument* owner)/* overload */;
	__fastcall TIcElementDecl(AnsiString name, Byte cType, TIcXMLDocument* owner)/* overload */;
	__fastcall virtual ~TIcElementDecl(void);
	void __fastcall SetContentModel(TIcContentModel* content);
	TIcContentModel* __fastcall GetContentModel(void);
};


class DELPHICLASS TIcCustomEntityDecl;
class PASCALIMPLEMENTATION TIcCustomEntityDecl : public TIcExternalNode 
{
	typedef TIcExternalNode inherited;
	
private:
	bool FInternal;
	
protected:
	__fastcall virtual TIcCustomEntityDecl(AnsiString name, TIcXMLDocument* owner)/* overload */;
	virtual void __fastcall Validate(void);
	virtual void __fastcall Normalize(void);
	virtual void __fastcall Write(Classes::TStream* stream, int l);
	
public:
	void __fastcall SetInternal(bool value);
	bool __fastcall IsInternal(void);
	HIDESBASE void __fastcall SetValue(AnsiString value);
	virtual void __fastcall Retrieve(void);
protected:
	#pragma option push -w-inl
	/* TIcXMLNode.Destroy */ inline __fastcall virtual ~TIcCustomEntityDecl(void) { }
	#pragma option pop
	
};


class DELPHICLASS TIcGEntityDecl;
class PASCALIMPLEMENTATION TIcGEntityDecl : public TIcCustomEntityDecl 
{
	typedef TIcCustomEntityDecl inherited;
	
private:
	AnsiString FNotation;
	bool FUnparsed;
	
protected:
	virtual void __fastcall Validate(void);
	
public:
	__fastcall virtual TIcGEntityDecl(AnsiString name, TIcXMLDocument* owner)/* overload */;
	void __fastcall SetNotation(AnsiString vNotation);
	AnsiString __fastcall GetNotation(void);
	void __fastcall SetUnparsed(bool value);
	bool __fastcall IsUnparsed(void);
	virtual void __fastcall Retrieve(void);
protected:
	#pragma option push -w-inl
	/* TIcXMLNode.Destroy */ inline __fastcall virtual ~TIcGEntityDecl(void) { }
	#pragma option pop
	
};


class DELPHICLASS TIcPEntityDecl;
class PASCALIMPLEMENTATION TIcPEntityDecl : public TIcCustomEntityDecl 
{
	typedef TIcCustomEntityDecl inherited;
	
public:
	__fastcall virtual TIcPEntityDecl(AnsiString name, TIcXMLDocument* owner)/* overload */;
protected:
	#pragma option push -w-inl
	/* TIcXMLNode.Destroy */ inline __fastcall virtual ~TIcPEntityDecl(void) { }
	#pragma option pop
	
};


class DELPHICLASS TIcCustomReference;
class PASCALIMPLEMENTATION TIcCustomReference : public TIcXMLNode 
{
	typedef TIcXMLNode inherited;
	
protected:
	Byte FDestType;
	virtual bool __fastcall Retrieve(void) = 0 ;
	Byte __fastcall GetDestType(void);
	
public:
	__fastcall TIcCustomReference(AnsiString name, TIcXMLDocument* owner)/* overload */;
protected:
	#pragma option push -w-inl
	/* TIcXMLNode.Destroy */ inline __fastcall virtual ~TIcCustomReference(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TIcGEntityReference : public TIcCustomReference 
{
	typedef TIcCustomReference inherited;
	
protected:
	virtual bool __fastcall Retrieve(void);
	void __fastcall ParseReference(TIcXMLDocument* &doc);
public:
	#pragma option push -w-inl
	/* TIcCustomReference.Create */ inline __fastcall TIcGEntityReference(AnsiString name, TIcXMLDocument* 
		owner)/* overload */ : TIcCustomReference(name, owner) { }
	#pragma option pop
	
protected:
	#pragma option push -w-inl
	/* TIcXMLNode.Destroy */ inline __fastcall virtual ~TIcGEntityReference(void) { }
	#pragma option pop
	
};


class DELPHICLASS TIcPEntityReference;
class PASCALIMPLEMENTATION TIcPEntityReference : public TIcCustomReference 
{
	typedef TIcCustomReference inherited;
	
protected:
	virtual bool __fastcall Retrieve(void);
	virtual void __fastcall Normalize(void);
	virtual void __fastcall Write(Classes::TStream* stream, int l);
public:
	#pragma option push -w-inl
	/* TIcCustomReference.Create */ inline __fastcall TIcPEntityReference(AnsiString name, TIcXMLDocument* 
		owner)/* overload */ : TIcCustomReference(name, owner) { }
	#pragma option pop
	
protected:
	#pragma option push -w-inl
	/* TIcXMLNode.Destroy */ inline __fastcall virtual ~TIcPEntityReference(void) { }
	#pragma option pop
	
};


class DELPHICLASS TIcCharReference;
class PASCALIMPLEMENTATION TIcCharReference : public TIcCustomReference 
{
	typedef TIcCustomReference inherited;
	
protected:
	virtual bool __fastcall Retrieve(void);
public:
	#pragma option push -w-inl
	/* TIcCustomReference.Create */ inline __fastcall TIcCharReference(AnsiString name, TIcXMLDocument* 
		owner)/* overload */ : TIcCustomReference(name, owner) { }
	#pragma option pop
	
protected:
	#pragma option push -w-inl
	/* TIcXMLNode.Destroy */ inline __fastcall virtual ~TIcCharReference(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TIcDocumentType : public TIcExternalNode 
{
	typedef TIcExternalNode inherited;
	
private:
	TIcNodeList* FContentList;
	
protected:
	virtual void __fastcall Write(Classes::TStream* stream, int l);
	virtual void __fastcall Validate(void);
	
public:
	__fastcall TIcDocumentType(AnsiString name, TIcXMLDocument* owner)/* overload */;
	__fastcall virtual ~TIcDocumentType(void);
	bool __fastcall SetAttListDecl(TIcAttListDecl* attListDecl);
	TIcAttListDecl* __fastcall GetAttListDecl(AnsiString name);
	void __fastcall SetAttDef(AnsiString elName, TIcAttDef* attDef);
	TIcAttDef* __fastcall GetAttDef(AnsiString elName, AnsiString attName);
	void __fastcall SetElementDecl(TIcElementDecl* elementDecl);
	TIcElementDecl* __fastcall GetElementDecl(AnsiString name);
	bool __fastcall SetEntityDecl(TIcCustomEntityDecl* entityDecl);
	TIcCustomEntityDecl* __fastcall GetEntityDecl(AnsiString name);
	void __fastcall SetComment(TIcXMLComment* comment);
	void __fastcall SetPI(TIcXMLPi* comment);
	TIcXMLPi* __fastcall GetPI(AnsiString name);
	void __fastcall SetPReference(TIcPEntityReference* ref);
	TIcPEntityReference* __fastcall GetPReference(AnsiString name);
	void __fastcall SetNotationDecl(TIcNotation* notation);
	TIcNotation* __fastcall GetNotation(AnsiString name);
	TIcNodeList* __fastcall GetContentList(void);
	void __fastcall RepleaceDeclaration(TIcXMLNode* oldNode, TIcXMLNode* newNode);
	TIcXMLNode* __fastcall RemoveNode(TIcXMLNode* oldNode);
	void __fastcall InsertNode(TIcXMLNode* newNode, TIcXMLNode* refNode);
	TIcXMLNode* __fastcall GetFirstNode(void);
	virtual void __fastcall Retrieve(void);
};


class DELPHICLASS TIcCharacterData;
class PASCALIMPLEMENTATION TIcCharacterData : public TIcXMLNode 
{
	typedef TIcXMLNode inherited;
	
public:
	virtual AnsiString __fastcall Data(void);
	virtual int __fastcall Length(void);
	virtual AnsiString __fastcall SubstringData(int offset, int count);
	virtual void __fastcall AppendData(AnsiString arg);
	virtual void __fastcall InsertData(int offset, AnsiString arg);
	virtual void __fastcall DeleteData(int offset, int count);
	virtual void __fastcall ReplaceData(int offset, int count, AnsiString arg);
protected:
	#pragma option push -w-inl
	/* TIcXMLNode.Create */ inline __fastcall virtual TIcCharacterData(AnsiString tagname, Byte nodeType
		, TIcXMLDocument* owner) : TIcXMLNode(tagname, nodeType, owner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TIcXMLNode.Destroy */ inline __fastcall virtual ~TIcCharacterData(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TIcXMLText : public TIcCharacterData 
{
	typedef TIcCharacterData inherited;
	
protected:
	virtual void __fastcall Write(Classes::TStream* stream, int l);
	virtual void __fastcall Normalize(void);
	__fastcall TIcXMLText(AnsiString data, TIcXMLDocument* owner, bool Dump)/* overload */;
	
public:
	__fastcall TIcXMLText(AnsiString data, TIcXMLDocument* owner)/* overload */;
	TIcXMLText* __fastcall SplitText(int offset);
	virtual TIcXMLNode* __fastcall CloneNode(void);
protected:
	#pragma option push -w-inl
	/* TIcXMLNode.Destroy */ inline __fastcall virtual ~TIcXMLText(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TIcXMLComment : public TIcXMLText 
{
	typedef TIcXMLText inherited;
	
protected:
	virtual void __fastcall Write(Classes::TStream* stream, int l);
	
public:
	__fastcall TIcXMLComment(AnsiString data, TIcXMLDocument* owner)/* overload */;
	virtual TIcXMLNode* __fastcall CloneNode(void);
protected:
	#pragma option push -w-inl
	/* TIcXMLNode.Destroy */ inline __fastcall virtual ~TIcXMLComment(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TIcXMLAttr : public TIcXMLNode 
{
	typedef TIcXMLNode inherited;
	
protected:
	bool StdAttrib;
	virtual void __fastcall Write(Classes::TStream* stream, int l);
	virtual void __fastcall Normalize(void);
	__fastcall TIcXMLAttr(AnsiString name, AnsiString value, TIcXMLDocument* owner, bool StandardAttribure
		, bool Dump)/* overload */;
	
public:
	__fastcall TIcXMLAttr(AnsiString name, AnsiString value, TIcXMLDocument* owner)/* overload */;
	__fastcall TIcXMLAttr(AnsiString name, AnsiString value, TIcXMLDocument* owner, bool StandardAttribure
		)/* overload */;
	virtual TIcXMLNode* __fastcall CloneNode(void);
	AnsiString __fastcall Name(void);
	bool __fastcall Specified(void);
	bool __fastcall StandardAttribute(void);
	AnsiString __fastcall Value(void);
	Byte __fastcall GetAttrType(void);
protected:
	#pragma option push -w-inl
	/* TIcXMLNode.Destroy */ inline __fastcall virtual ~TIcXMLAttr(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TIcXMLElement : public TIcContainer 
{
	typedef TIcContainer inherited;
	
protected:
	void __fastcall GetByTagName(AnsiString name, TIcNodeList* list);
	void __fastcall GetByType(Byte aType, TIcNodeList* list);
	void __fastcall SetDocument(TIcXMLDocument* doc);
	virtual void __fastcall Validate(void);
	virtual void __fastcall Write(Classes::TStream* stream, int l);
	
public:
	__fastcall TIcXMLElement(AnsiString tagName, TIcXMLDocument* owner)/* overload */;
	HIDESBASE TIcXMLElement* __fastcall PreviousSibling(void);
	HIDESBASE TIcXMLElement* __fastcall NextSibling(void);
	__fastcall virtual ~TIcXMLElement(void);
	AnsiString __fastcall TagName(void);
	TIcNodeList* __fastcall GetElementsByTagName(AnsiString name);
	TIcNodeList* __fastcall GetAttributesByType(Byte aType);
	virtual TIcXMLNode* __fastcall CloneNode(void);
	void __fastcall AppendChild(TIcXMLElement* newChild);
	bool __fastcall HasChild(void);
	TIcXMLElement* __fastcall RemoveChild(TIcXMLElement* child);
	TIcXMLElement* __fastcall GetFirstChild(void);
	TIcXMLElement* __fastcall GetChild(int index);
	void __fastcall GetChildren(TIcNodeList* list);
	void __fastcall SetCharData(TIcXMLText* data);
	TIcXMLText* __fastcall GetFirstCharData(void);
	void __fastcall GetCharDatas(TIcNodeList* list);
	bool __fastcall HasCharData(void);
	void __fastcall RemoveCharData(TIcXMLText* Node);
	void __fastcall SetCData(TIcXMLCData* data);
	TIcXMLCData* __fastcall GetFirstCData(void);
	void __fastcall GetCDatas(TIcNodeList* list);
	bool __fastcall HasCData(void);
	void __fastcall RemoveCData(TIcXMLCData* Node);
	HIDESBASE TIcXMLNode* __fastcall GetParent(void);
	void __fastcall InsertElementContent(TIcXMLElement* el);
};


class PASCALIMPLEMENTATION TIcXMLCData : public TIcXMLText 
{
	typedef TIcXMLText inherited;
	
protected:
	virtual void __fastcall Write(Classes::TStream* stream, int l);
	
public:
	__fastcall TIcXMLCData(AnsiString data, TIcXMLDocument* owner)/* overload */;
	virtual TIcXMLNode* __fastcall CloneNode(void);
protected:
	#pragma option push -w-inl
	/* TIcXMLNode.Destroy */ inline __fastcall virtual ~TIcXMLCData(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TIcXMLPi : public TIcXMLNode 
{
	typedef TIcXMLNode inherited;
	
protected:
	virtual void __fastcall Write(Classes::TStream* stream, int l);
	
public:
	__fastcall virtual TIcXMLPi(AnsiString target, AnsiString data, TIcXMLDocument* owner)/* overload */
		;
	AnsiString __fastcall Target(void);
	AnsiString __fastcall Data(void);
	virtual TIcXMLNode* __fastcall CloneNode(void);
protected:
	#pragma option push -w-inl
	/* TIcXMLNode.Destroy */ inline __fastcall virtual ~TIcXMLPi(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TIcDocumentFragment : public TIcXMLNode 
{
	typedef TIcXMLNode inherited;
	
protected:
	TIcNodeList* FContent;
	__fastcall TIcDocumentFragment(TIcXMLDocument* owner)/* overload */;
	__fastcall virtual ~TIcDocumentFragment(void);
};


struct TAnalyzerState
{
	TInputBuffer* FirstBuffer;
	TInputBuffer* SecondBuffer;
	TInputBuffer* Buffer;
	TSymTab* Symbols;
	TSTEntry* PrevToken;
	TSTEntry* CurToken;
	char CurChar;
	TXMLStack* Stack;
	int LineNumber;
	AnsiString FileName;
} ;

class DELPHICLASS TDTDParser;
class PASCALIMPLEMENTATION TDTDParser : public TLexAnalyzer 
{
	typedef TLexAnalyzer inherited;
	
protected:
	virtual void __fastcall LexAn(void);
	virtual void __fastcall Emit(int nodeType, AnsiString val);
	virtual void __fastcall MEmit(int nodeType, AnsiString val1, AnsiString val2);
	void __fastcall ParseDTDContent(void);
	void __fastcall ParseElDecl(void);
	void __fastcall ParseAttrDecl(void);
	void __fastcall ParseEnumType(void);
	void __fastcall ParseNotationType(void);
	void __fastcall ParseEntityDecl(void);
	void __fastcall ParseNotation(void);
	void __fastcall Parse(const TAnalyzerState &state, TIcXMLDocument* &doc)/* overload */;
	
public:
	void __fastcall Parse(Classes::TStream* stream, TIcXMLDocument* &doc)/* overload */;
	void __fastcall Parse(AnsiString fname, TIcXMLDocument* &doc)/* overload */;
public:
	#pragma option push -w-inl
	/* TLexAnalyzer.Create */ inline __fastcall virtual TDTDParser(Classes::TComponent* AOwner) : TLexAnalyzer(
		AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TLexAnalyzer.Destroy */ inline __fastcall virtual ~TDTDParser(void) { }
	#pragma option pop
	
};


class DELPHICLASS TContentModelParser;
class PASCALIMPLEMENTATION TContentModelParser : public TLexAnalyzer 
{
	typedef TLexAnalyzer inherited;
	
protected:
	virtual void __fastcall LexAn(void);
	virtual void __fastcall Emit(int nodeType, AnsiString val);
	virtual void __fastcall MEmit(int nodeType, AnsiString val1, AnsiString val2);
	void __fastcall ParseContentModel(void);
	void __fastcall ParseCMExp(void);
	void __fastcall ParseCMSeq(void);
	void __fastcall Parse(const TAnalyzerState &state, TIcXMLDocument* &doc)/* overload */;
	
public:
	void __fastcall Parse(AnsiString stringModel, TIcContentModel* &cm, TIcXMLDocument* doc)/* overload */
		;
public:
	#pragma option push -w-inl
	/* TLexAnalyzer.Create */ inline __fastcall virtual TContentModelParser(Classes::TComponent* AOwner
		) : TLexAnalyzer(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TLexAnalyzer.Destroy */ inline __fastcall virtual ~TContentModelParser(void) { }
	#pragma option pop
	
};


class DELPHICLASS TContentModelAnalyzer;
class PASCALIMPLEMENTATION TContentModelAnalyzer : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TIcXMLNode* CurNode;
	bool __fastcall Equal(TIcXMLNode* node);
	bool __fastcall Match(TIcXMLNode* node);
	
public:
	bool __fastcall MatchContentModel(TIcNodeList* list, TIcContentModel* content);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TContentModelAnalyzer(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TContentModelAnalyzer(void) { }
	#pragma option pop
	
};


class DELPHICLASS EIcXMLParserError;
class PASCALIMPLEMENTATION EIcXMLParserError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	int LineNumber;
	int ExtLineNumber;
	AnsiString FileName;
	__fastcall EIcXMLParserError(const AnsiString msg, int lNumber, bool Dummy);
	__fastcall EIcXMLParserError(const AnsiString msg, AnsiString fName, int lNumber);
	__fastcall EIcXMLParserError(const AnsiString msg, AnsiString fName, int lNumber, int extLNumber);
	__fastcall virtual ~EIcXMLParserError(void);
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall EIcXMLParserError(const AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIcXMLParserError(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIcXMLParserError(int Ident)/* overload */ : Sysutils::Exception(
		Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIcXMLParserError(int Ident, const System::TVarRec * 
		Args, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIcXMLParserError(const AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIcXMLParserError(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIcXMLParserError(int Ident, int AHelpContext)/* overload */
		 : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIcXMLParserError(System::PResStringRec ResStringRec
		, const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(
		ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
};


class DELPHICLASS TXMLHandleStream;
class PASCALIMPLEMENTATION TXMLHandleStream : public Classes::TStream 
{
	typedef Classes::TStream inherited;
	
protected:
	unsigned FHandle;
	virtual void __fastcall SetSize(int NewSize);
	
public:
	__fastcall TXMLHandleStream(int AHandle);
	virtual int __fastcall Read(void *Buffer, int Count);
	virtual int __fastcall Write(const void *Buffer, int Count);
	virtual int __fastcall Seek(int Offset, Word Origin);
	__property unsigned Handle = {read=FHandle, nodefault};
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TXMLHandleStream(void) { }
	#pragma option pop
	
};


class DELPHICLASS TXMLFileStream;
class PASCALIMPLEMENTATION TXMLFileStream : public TXMLHandleStream 
{
	typedef TXMLHandleStream inherited;
	
public:
	__fastcall TXMLFileStream(const AnsiString FileName, unsigned dwDesiredAccess, unsigned dwShareMode
		, unsigned dwCreationDistribution, unsigned dwFlagsAndAttributes);
	__fastcall virtual ~TXMLFileStream(void);
};


class DELPHICLASS TIcError;
class PASCALIMPLEMENTATION TIcError : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	AnsiString Msg;
	TIcXMLNode* Node;
	__fastcall TIcError(AnsiString msg, TIcXMLNode* node);
	__fastcall virtual ~TIcError(void);
};


//-- var, const, procedure ---------------------------------------------------
static const Shortint IcNONE = 0xffffffff;
static const char IcEOF = '\x0';
#define IcCRLF "\r\n"
static const Shortint CharSize = 0x1;
static const char IcCR = '\xd';
static const char IcLF = '\xa';
static const char IcTAB = '\x9';
static const char IcSpace = '\x20';
static const Byte PRIME = 0xd3;
static const Word tkComntStag = 0x100;
static const Word tkPIStag = 0x101;
static const Word tkCDStag = 0x102;
static const Word tkXMLStag = 0x103;
static const Word tkDTDStag = 0x104;
static const Word tkStag = 0x105;
static const Word tkEtag = 0x106;
static const Word tkEmptyEtag = 0x107;
static const Word tkElemEtag = 0x108;
static const Word tkElemDecl = 0x109;
static const Word tkAttrDecl = 0x10a;
static const Word tkIncludeSec = 0x10b;
static const Word tkEntityDecl = 0x10c;
static const Word tkComntEtag = 0x10d;
static const Word tkPIEtag = 0x10e;
static const Word tkCDEtag = 0x10f;
static const Word tkPcdata = 0x110;
static const Word tkRequired = 0x111;
static const Word tkImplied = 0x112;
static const Word tkFixed = 0x113;
static const Word tkNotSTag = 0x114;
static const Word tkName = 0x12c;
static const Word tkLiteral = 0x12e;
static const Word tkCharData = 0x12f;
static const Word tkReference = 0x130;
static const Word tkDTD = 0x131;
static const Word tkCharRef = 0x132;
static const Word tkNmtoken = 0x133;
static const Word tkDone = 0x190;
static const Word tkUnknown = 0x191;
#define lxVersion "version"
#define lxEncoding "encoding"
#define lxStandalone "standalone"
#define lxEmpty "EMPTY"
#define lxAny "ANY"
#define lxCdata "CDATA"
#define lxID "ID"
#define lxIDRef "IDREF"
#define lxIDRefs "IDREFS"
#define lxEntity "ENTITY"
#define lxEntities "ENTITIES"
#define lxNmtoken "NMTOKEN"
#define lxNmtokens "NMTOKENS"
#define lxNotation "NOTATION"
#define lxInclude "INCLUDE"
#define lxIgnore "IGNORE"
#define lxSystem "SYSTEM"
#define lxPublic "PUBLIC"
#define lxNdata "NDATA"
#define lxRequired "#REQUIRED"
#define lxImplied "#IMPLIED"
#define lxFixed "#FIXED"
#define refLt "&lt;"
#define refGt "&gt;"
#define refAmp "&amp;"
#define refQuot "&quot;"
#define refApos "&apos;"
static const Shortint INDEX_SIZE_ERR = 0x1;
static const Shortint DOMSTRING_SIZE_ERR = 0x2;
static const Shortint HIERARCHY_REQUEST_ERR = 0x3;
static const Shortint WRONG_DOCUMENT_ERR = 0x4;
static const Shortint INVALID_CHARACTER_ERR = 0x5;
static const Shortint NO_DATA_ALLOWED_ERR = 0x6;
static const Shortint NO_MODIFICATION_ALLOWED_ERR = 0x7;
static const Shortint NOT_FOUND_ERR = 0x8;
static const Shortint NOT_SUPPORTED_ERR = 0x9;
static const Shortint INUSE_ATTRIBUTE_ERR = 0xa;
static const Shortint WRONG_ELEMENT_NAME = 0xb;
static const Shortint INVALID_POINTER_ERR = 0xc;
static const Shortint UNIQUE_EL_DECL_REQ = 0xd;
static const Shortint NO_DUPLICATE_TYPES = 0xe;
static const Shortint UNIQUE_ATTRIBUTE_ERR = 0xf;
static const Shortint ntUnknown = 0x0;
static const Shortint ntElement = 0x1;
static const Shortint ntAttribute = 0x2;
static const Shortint ntText = 0x3;
static const Shortint ntCData = 0x4;
static const Shortint ntComment = 0x5;
static const Shortint ntPI = 0x6;
static const Shortint ntReference = 0x7;
static const Shortint ntElementDecl = 0x8;
static const Shortint ntAttDef = 0x9;
static const Shortint ntEntity = 0xa;
static const Shortint ntNotation = 0xb;
static const Shortint ntDocument = 0xd;
static const Shortint ntDocumentType = 0xc;
static const Shortint ntDocumentFragment = 0xe;
static const Shortint ntElementEnd = 0xf;
static const Shortint ntContent = 0x10;
static const Shortint ntElementContent = 0x11;
static const Shortint ntAttListDecl = 0x12;
static const Shortint ntEntityEnd = 0x13;
static const Shortint ntElementContentStart = 0x14;
static const Shortint ntElementContentEnd = 0x15;
static const Shortint ntElementContentDelimiter = 0x16;
static const Shortint ntEnumType = 0x17;
static const Shortint ntEnumElement = 0x18;
static const Shortint ntAttDefType = 0x19;
static const Shortint ntAttDefEnd = 0x1a;
static const Shortint ntEntityValue = 0x1b;
static const Shortint ntExternSystem = 0x1c;
static const Shortint ntExternPublic = 0x1d;
static const Shortint ntExternNData = 0x1e;
static const Shortint ntWhiteText = 0x1f;
static const Shortint tcQuest = 0x28;
static const Shortint tcNone = 0x29;
static const Shortint tcOneBase = 0x2a;
static const Shortint tcZeroBase = 0x2b;
static const Shortint ctEmpty = 0x2d;
static const Shortint ctAny = 0x2e;
static const Shortint ctMixed = 0x2f;
static const Shortint ctChildren = 0x30;
static const Shortint atID = 0x32;
static const Shortint atIDRef = 0x33;
static const Shortint atIDRefs = 0x34;
static const Shortint atEntity = 0x35;
static const Shortint atEntities = 0x36;
static const Shortint atNmtoken = 0x37;
static const Shortint atNmtokens = 0x38;
static const Shortint atNotation = 0x39;
static const Shortint atCData = 0x3a;
static const Shortint atEnumeration = 0x3b;
static const Shortint dtRequired = 0x3c;
static const Shortint dtImplied = 0x3d;
static const Shortint dtFixed = 0x3e;
static const Shortint dtDefault = 0x3f;
static const Shortint etParameter = 0x41;
static const Shortint etInternal = 0x42;
static const Shortint etExternal = 0x43;
static const Shortint etUnparsed = 0x44;
static const Shortint etChar = 0x45;
static const Shortint etUnknown = 0x46;
static const Shortint pmDocument = 0x64;
static const Shortint pmExtParsedEntity = 0x65;
static const Shortint fpName = 0x1;
static const Shortint fpValue = 0x2;
static const Shortint fpSeDTD = 0x4;
static const Shortint fpSeBody = 0x8;
static const Shortint fpCaseSensitive = 0x10;
static const Shortint fpWholeWords = 0x20;
static const int BLOCKSIZE = 0x19001;
static const Shortint WhiteCount = 0x2;
static const char WhiteChar = '\x20';
#define PublicIdSearchEngine "http://www.ucc.ie/cgi-bin/PUBLIC?"
extern PACKAGE void __fastcall Register(void);
extern PACKAGE bool __fastcall IsWin95(void);
extern PACKAGE bool __fastcall IsChar(char c);
extern PACKAGE bool __fastcall IsLetter(char c);
extern PACKAGE bool __fastcall IsDigit(char c);
extern PACKAGE bool __fastcall IsAlphaNum(char c);
extern PACKAGE bool __fastcall IsWhite(char c);
extern PACKAGE bool __fastcall IsFirstNameChar(char c);
extern PACKAGE bool __fastcall IsNameChar(char c);
extern PACKAGE bool __fastcall IsPubidChar(char c);
extern PACKAGE bool __fastcall IsRightBracket(char c);
extern PACKAGE bool __fastcall IsDataChar(char c);
extern PACKAGE bool __fastcall IsHexDigit(char c);
extern PACKAGE bool __fastcall IsValidName(AnsiString name);
extern PACKAGE bool __fastcall IsValidToken(AnsiString name);
extern PACKAGE bool __fastcall AreValidNames(AnsiString value, Classes::TStrings* sList);
extern PACKAGE bool __fastcall AreValidTokens(AnsiString value, Classes::TStrings* sList);
extern PACKAGE bool __fastcall IsValidPIData(AnsiString target);
extern PACKAGE AnsiString __fastcall LeadWhite(int len);
extern PACKAGE AnsiString __fastcall CharToReference(AnsiString str, char c);
extern PACKAGE AnsiString __fastcall CharsToReference(AnsiString str);
extern PACKAGE int __fastcall HexStrToInt(AnsiString str);

}	/* namespace Icxmlparser */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Icxmlparser;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// IcXMLParser
